var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var _left, _right;
class BidirectionalMap {
  constructor(iterable) {
    __privateAdd(this, _left, /* @__PURE__ */ new Map());
    __privateAdd(this, _right, /* @__PURE__ */ new Map());
    if (iterable) {
      for (const [key, value] of iterable) {
        __privateGet(this, _left).set(key, value);
        __privateGet(this, _right).set(value, key);
      }
    }
  }
  get size() {
    return __privateGet(this, _left).size;
  }
  clear() {
    __privateGet(this, _left).clear();
    __privateGet(this, _right).clear();
  }
  deleteLeft(key) {
    const value = __privateGet(this, _left).get(key);
    if (value !== void 0) {
      __privateGet(this, _left).delete(key);
      __privateGet(this, _right).delete(value);
      return true;
    }
    return false;
  }
  deleteRight(value) {
    const key = __privateGet(this, _right).get(value);
    if (key !== void 0) {
      __privateGet(this, _right).delete(value);
      __privateGet(this, _left).delete(key);
      return true;
    }
    return false;
  }
  getLeft(key) {
    return __privateGet(this, _left).get(key);
  }
  getRight(value) {
    return __privateGet(this, _right).get(value);
  }
  hasLeft(key) {
    return __privateGet(this, _left).has(key);
  }
  hasRight(value) {
    return __privateGet(this, _right).has(value);
  }
  set(key, value) {
    __privateGet(this, _left).set(key, value);
    __privateGet(this, _right).set(value, key);
    return this;
  }
  [Symbol.iterator]() {
    return __privateGet(this, _left)[Symbol.iterator]();
  }
  entries() {
    return __privateGet(this, _left).entries();
  }
  keys() {
    return __privateGet(this, _left).keys();
  }
  values() {
    return __privateGet(this, _left).values();
  }
  get [Symbol.toStringTag]() {
    return "BidirectionalMap";
  }
}
_left = new WeakMap();
_right = new WeakMap();

export { BidirectionalMap };
