interface CompositeKeyMapOptions<Key> {
    mapKey?: (a: Key) => any;
    compareKeys?: ((a: Key, b: Key) => number) | null;
}
declare class CompositeKeyMap<Key, Value> {
    #private;
    constructor(options?: CompositeKeyMapOptions<Key>);
    set(keys: Array<Key>, value: Value): void;
    get(keys: Array<Key>): Value | undefined;
    delete(keys: Array<Key>): boolean;
    has(keys: Array<Key>): boolean;
    clear(): void;
    keys(): Generator<Array<Key>>;
    values(): Generator<Value>;
    entries(): Generator<[Array<Key>, Value]>;
}

export { CompositeKeyMap };
