interface CompositeKeyMultiMapOptions<Key> {
    mapKey?: (a: Key) => any;
    compareKeys?: ((a: Key, b: Key) => number) | null;
}
declare class CompositeKeyMultiMap<Key, Value> {
    #private;
    constructor(options?: CompositeKeyMultiMapOptions<Key>);
    set(keys: Array<Key>, value: Value): void;
    get(keys: Array<Key>): ReadonlySet<Value>;
    delete(keys: Array<Key>): boolean;
    has(keys: Array<Key>): boolean;
    clear(): void;
    keys(): Generator<Array<Key>>;
    values(): Generator<ReadonlySet<Value>>;
    entries(): Generator<[Array<Key>, ReadonlySet<Value>]>;
}

export { CompositeKeyMultiMap };
