'use strict';

const maps_BidirectionalMap = require('./BidirectionalMap.cjs');

var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};
var _storage, _emptySet, _keys, _mapKey, _key, key_fn, _a;
class MultiMap {
  constructor(iterable, options = {}) {
    __privateAdd(this, _key);
    // biome-ignore lint/suspicious/noExplicitAny: any is needed for type inference
    __privateAdd(this, _storage, /* @__PURE__ */ new Map());
    __privateAdd(this, _emptySet, /* @__PURE__ */ new Set());
    // biome-ignore lint/suspicious/noExplicitAny: any is needed for type inference
    __privateAdd(this, _keys, new maps_BidirectionalMap.BidirectionalMap(null));
    // biome-ignore lint/suspicious/noExplicitAny: any is needed for type inference
    __privateAdd(this, _mapKey, void 0);
    __publicField(this, _a, "MultiMap");
    __privateSet(this, _mapKey, options.mapKey ?? null);
    if (iterable) {
      for (const [key, value] of iterable) {
        this.set(key, value);
      }
    }
  }
  get size() {
    return __privateGet(this, _storage).size;
  }
  clear() {
    __privateGet(this, _keys).clear();
    __privateGet(this, _storage).clear();
  }
  delete(key, value) {
    const mapped = __privateMethod(this, _key, key_fn).call(this, key);
    let existed = false;
    if (value !== void 0) {
      const storage = __privateGet(this, _storage).get(mapped);
      if (storage) {
        existed = storage.delete(value);
      }
    } else {
      existed = __privateGet(this, _storage).delete(mapped);
    }
    return existed;
  }
  get(key) {
    return __privateGet(this, _storage).get(__privateMethod(this, _key, key_fn).call(this, key)) ?? __privateGet(this, _emptySet);
  }
  has(key) {
    return __privateGet(this, _storage).has(__privateMethod(this, _key, key_fn).call(this, key));
  }
  set(key, value) {
    const mapped = __privateMethod(this, _key, key_fn).call(this, key);
    let storage = __privateGet(this, _storage).get(mapped);
    if (!storage) {
      storage = /* @__PURE__ */ new Set();
      __privateGet(this, _storage).set(mapped, storage);
    }
    storage.add(value);
    return this;
  }
  *entries() {
    for (const [key, values] of __privateGet(this, _storage).entries()) {
      yield [__privateGet(this, _mapKey) ? __privateGet(this, _keys).getRight(key) : key, values];
    }
  }
  *keys() {
    for (const key of __privateGet(this, _storage).keys()) {
      yield __privateGet(this, _mapKey) ? __privateGet(this, _keys).getRight(key) : key;
    }
  }
  values() {
    return __privateGet(this, _storage).values();
  }
}
_a = Symbol.toStringTag;
_storage = new WeakMap();
_emptySet = new WeakMap();
_keys = new WeakMap();
_mapKey = new WeakMap();
_key = new WeakSet();
key_fn = function(key) {
  if (__privateGet(this, _mapKey)) {
    let mapped = __privateGet(this, _keys).getLeft(key);
    if (!mapped) {
      mapped = __privateGet(this, _mapKey).call(this, key);
      __privateGet(this, _keys).set(key, mapped);
    }
    return mapped;
  }
  return key;
};

exports.MultiMap = MultiMap;
