interface MultiMapOptions<Key> {
    mapKey?: null | ((key: Key) => any);
}
declare class MultiMap<Key, Value> {
    #private;
    constructor(iterable?: Iterable<readonly [Key, Value]> | null, options?: MultiMapOptions<Key>);
    get size(): number;
    clear(): void;
    delete(key: Key, value?: Value): boolean;
    get(key: Key): Set<Value>;
    has(key: Key): boolean;
    set(key: Key, value: Value): this;
    entries(): IterableIterator<[Key, ReadonlySet<Value>]>;
    keys(): IterableIterator<Key>;
    values(): IterableIterator<ReadonlySet<Value>>;
    [Symbol.toStringTag]: string;
}

export { MultiMap };
